//#line 2 "/opt/ros/hydro/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
// 
// File autogenerated for the avt_vimba_camera package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __avt_vimba_camera__AVTVIMBACAMERACONFIG_H__
#define __avt_vimba_camera__AVTVIMBACAMERACONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace avt_vimba_camera
{
  class AvtVimbaCameraConfigStatics;
  
  class AvtVimbaCameraConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(AvtVimbaCameraConfig &config, const AvtVimbaCameraConfig &max, const AvtVimbaCameraConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const AvtVimbaCameraConfig &config1, const AvtVimbaCameraConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, AvtVimbaCameraConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const AvtVimbaCameraConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, AvtVimbaCameraConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const AvtVimbaCameraConfig &config) const = 0;
      virtual void getValue(const AvtVimbaCameraConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T AvtVimbaCameraConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (AvtVimbaCameraConfig::* field);

      virtual void clamp(AvtVimbaCameraConfig &config, const AvtVimbaCameraConfig &max, const AvtVimbaCameraConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const AvtVimbaCameraConfig &config1, const AvtVimbaCameraConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, AvtVimbaCameraConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const AvtVimbaCameraConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, AvtVimbaCameraConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const AvtVimbaCameraConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const AvtVimbaCameraConfig &config, boost::any &val) const
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, AvtVimbaCameraConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    template<class T, class PT>
    class GroupDescription : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string name, std::string type, int parent, int id, bool s, T PT::* f) : AbstractGroupDescription(name, type, parent, id, s), field(f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, AvtVimbaCameraConfig &top) const
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T (PT::* field);
      std::vector<AvtVimbaCameraConfig::AbstractGroupDescriptionConstPtr> groups;
    };
    
class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(AvtVimbaCameraConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("guid"==(*_i)->name){guid = boost::any_cast<std::string>(val);}
        if("ip_address"==(*_i)->name){ip_address = boost::any_cast<std::string>(val);}
        if("camera_info_url"==(*_i)->name){camera_info_url = boost::any_cast<std::string>(val);}
        if("frame_id"==(*_i)->name){frame_id = boost::any_cast<std::string>(val);}
        if("trig_timestamp_topic"==(*_i)->name){trig_timestamp_topic = boost::any_cast<std::string>(val);}
        if("acquisition_mode"==(*_i)->name){acquisition_mode = boost::any_cast<std::string>(val);}
        if("acquisition_rate"==(*_i)->name){acquisition_rate = boost::any_cast<double>(val);}
        if("trigger_mode"==(*_i)->name){trigger_mode = boost::any_cast<std::string>(val);}
        if("trigger_activation"==(*_i)->name){trigger_activation = boost::any_cast<std::string>(val);}
        if("trigger_delay"==(*_i)->name){trigger_delay = boost::any_cast<double>(val);}
        if("exposure"==(*_i)->name){exposure = boost::any_cast<double>(val);}
        if("exposure_auto"==(*_i)->name){exposure_auto = boost::any_cast<std::string>(val);}
        if("exposure_auto_tol"==(*_i)->name){exposure_auto_tol = boost::any_cast<int>(val);}
        if("exposure_auto_max"==(*_i)->name){exposure_auto_max = boost::any_cast<int>(val);}
        if("exposure_auto_min"==(*_i)->name){exposure_auto_min = boost::any_cast<int>(val);}
        if("exposure_auto_outliers"==(*_i)->name){exposure_auto_outliers = boost::any_cast<int>(val);}
        if("exposure_auto_rate"==(*_i)->name){exposure_auto_rate = boost::any_cast<int>(val);}
        if("exposure_auto_target"==(*_i)->name){exposure_auto_target = boost::any_cast<int>(val);}
        if("gain"==(*_i)->name){gain = boost::any_cast<double>(val);}
        if("gain_auto"==(*_i)->name){gain_auto = boost::any_cast<std::string>(val);}
        if("gain_auto_tol"==(*_i)->name){gain_auto_tol = boost::any_cast<int>(val);}
        if("gain_auto_max"==(*_i)->name){gain_auto_max = boost::any_cast<double>(val);}
        if("gain_auto_min"==(*_i)->name){gain_auto_min = boost::any_cast<double>(val);}
        if("gain_auto_outliers"==(*_i)->name){gain_auto_outliers = boost::any_cast<int>(val);}
        if("gain_auto_rate"==(*_i)->name){gain_auto_rate = boost::any_cast<int>(val);}
        if("gain_auto_target"==(*_i)->name){gain_auto_target = boost::any_cast<int>(val);}
        if("balance_ratio_abs"==(*_i)->name){balance_ratio_abs = boost::any_cast<double>(val);}
        if("balance_ratio_selector"==(*_i)->name){balance_ratio_selector = boost::any_cast<std::string>(val);}
        if("whitebalance_auto"==(*_i)->name){whitebalance_auto = boost::any_cast<std::string>(val);}
        if("whitebalance_auto_tol"==(*_i)->name){whitebalance_auto_tol = boost::any_cast<int>(val);}
        if("whitebalance_auto_rate"==(*_i)->name){whitebalance_auto_rate = boost::any_cast<int>(val);}
        if("binning_x"==(*_i)->name){binning_x = boost::any_cast<int>(val);}
        if("binning_y"==(*_i)->name){binning_y = boost::any_cast<int>(val);}
        if("decimation_x"==(*_i)->name){decimation_x = boost::any_cast<int>(val);}
        if("decimation_y"==(*_i)->name){decimation_y = boost::any_cast<int>(val);}
        if("width"==(*_i)->name){width = boost::any_cast<int>(val);}
        if("height"==(*_i)->name){height = boost::any_cast<int>(val);}
        if("roi_width"==(*_i)->name){roi_width = boost::any_cast<int>(val);}
        if("roi_height"==(*_i)->name){roi_height = boost::any_cast<int>(val);}
        if("roi_offset_x"==(*_i)->name){roi_offset_x = boost::any_cast<int>(val);}
        if("roi_offset_y"==(*_i)->name){roi_offset_y = boost::any_cast<int>(val);}
        if("pixel_format"==(*_i)->name){pixel_format = boost::any_cast<std::string>(val);}
        if("stream_bytes_per_second"==(*_i)->name){stream_bytes_per_second = boost::any_cast<int>(val);}
        if("sync_in_selector"==(*_i)->name){sync_in_selector = boost::any_cast<std::string>(val);}
        if("sync_out_polarity"==(*_i)->name){sync_out_polarity = boost::any_cast<std::string>(val);}
        if("sync_out_selector"==(*_i)->name){sync_out_selector = boost::any_cast<std::string>(val);}
        if("sync_out_source"==(*_i)->name){sync_out_source = boost::any_cast<std::string>(val);}
      }
    }

    std::string guid;
std::string ip_address;
std::string camera_info_url;
std::string frame_id;
std::string trig_timestamp_topic;
std::string acquisition_mode;
double acquisition_rate;
std::string trigger_mode;
std::string trigger_activation;
double trigger_delay;
double exposure;
std::string exposure_auto;
int exposure_auto_tol;
int exposure_auto_max;
int exposure_auto_min;
int exposure_auto_outliers;
int exposure_auto_rate;
int exposure_auto_target;
double gain;
std::string gain_auto;
int gain_auto_tol;
double gain_auto_max;
double gain_auto_min;
int gain_auto_outliers;
int gain_auto_rate;
int gain_auto_target;
double balance_ratio_abs;
std::string balance_ratio_selector;
std::string whitebalance_auto;
int whitebalance_auto_tol;
int whitebalance_auto_rate;
int binning_x;
int binning_y;
int decimation_x;
int decimation_y;
int width;
int height;
int roi_width;
int roi_height;
int roi_offset_x;
int roi_offset_y;
std::string pixel_format;
int stream_bytes_per_second;
std::string sync_in_selector;
std::string sync_out_polarity;
std::string sync_out_selector;
std::string sync_out_source;

    bool state;
    std::string name;

    
}groups;



//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string guid;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string ip_address;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string camera_info_url;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string frame_id;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string trig_timestamp_topic;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string acquisition_mode;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double acquisition_rate;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string trigger_mode;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string trigger_activation;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double trigger_delay;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double exposure;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string exposure_auto;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int exposure_auto_tol;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int exposure_auto_max;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int exposure_auto_min;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int exposure_auto_outliers;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int exposure_auto_rate;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int exposure_auto_target;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double gain;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string gain_auto;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int gain_auto_tol;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double gain_auto_max;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double gain_auto_min;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int gain_auto_outliers;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int gain_auto_rate;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int gain_auto_target;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double balance_ratio_abs;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string balance_ratio_selector;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string whitebalance_auto;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int whitebalance_auto_tol;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int whitebalance_auto_rate;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int binning_x;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int binning_y;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int decimation_x;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int decimation_y;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int width;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int height;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int roi_width;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int roi_height;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int roi_offset_x;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int roi_offset_y;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string pixel_format;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int stream_bytes_per_second;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string sync_in_selector;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string sync_out_polarity;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string sync_out_selector;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string sync_out_source;
//#line 255 "/opt/ros/hydro/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("AvtVimbaCameraConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const AvtVimbaCameraConfig &__max__ = __getMax__();
      const AvtVimbaCameraConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const AvtVimbaCameraConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const AvtVimbaCameraConfig &__getDefault__();
    static const AvtVimbaCameraConfig &__getMax__();
    static const AvtVimbaCameraConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();
    
  private:
    static const AvtVimbaCameraConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void AvtVimbaCameraConfig::ParamDescription<std::string>::clamp(AvtVimbaCameraConfig &config, const AvtVimbaCameraConfig &max, const AvtVimbaCameraConfig &min) const
  {
    return;
  }

  class AvtVimbaCameraConfigStatics
  {
    friend class AvtVimbaCameraConfig;
    
    AvtVimbaCameraConfigStatics()
    {
AvtVimbaCameraConfig::GroupDescription<AvtVimbaCameraConfig::DEFAULT, AvtVimbaCameraConfig> Default("Default", "", 0, 0, true, &AvtVimbaCameraConfig::groups);
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.guid = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.guid = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.guid = "50-0503328910";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("guid", "str", 3, "Global Unique ID of camera, XX-XXXXXXXXXX digits", "", &AvtVimbaCameraConfig::guid)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("guid", "str", 3, "Global Unique ID of camera, XX-XXXXXXXXXX digits", "", &AvtVimbaCameraConfig::guid)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.ip_address = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.ip_address = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.ip_address = "192.168.3.103";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("ip_address", "str", 3, "IP of camera, four pairs of two digits separated by points: 192.168.1.3", "", &AvtVimbaCameraConfig::ip_address)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("ip_address", "str", 3, "IP of camera, four pairs of two digits separated by points: 192.168.1.3", "", &AvtVimbaCameraConfig::ip_address)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.camera_info_url = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.camera_info_url = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.camera_info_url = "camera_info.yaml";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("camera_info_url", "str", 0, "Camera calibration URL for this video_mode (uncalibrated if null).", "", &AvtVimbaCameraConfig::camera_info_url)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("camera_info_url", "str", 0, "Camera calibration URL for this video_mode (uncalibrated if null).", "", &AvtVimbaCameraConfig::camera_info_url)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.frame_id = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.frame_id = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.frame_id = "camera";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("frame_id", "str", 0, "The optical camera TF frame set in message headers.", "", &AvtVimbaCameraConfig::frame_id)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("frame_id", "str", 0, "The optical camera TF frame set in message headers.", "", &AvtVimbaCameraConfig::frame_id)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.trig_timestamp_topic = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.trig_timestamp_topic = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.trig_timestamp_topic = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("trig_timestamp_topic", "str", 1, "Sets the topic from which an externally trigged camera receives its trigger timestamps.", "", &AvtVimbaCameraConfig::trig_timestamp_topic)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("trig_timestamp_topic", "str", 1, "Sets the topic from which an externally trigged camera receives its trigger timestamps.", "", &AvtVimbaCameraConfig::trig_timestamp_topic)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.acquisition_mode = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.acquisition_mode = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.acquisition_mode = "Continuous";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("acquisition_mode", "str", 1, "Camera acquisition mode", "{'enum_description': 'Set Trigger Mode', 'enum': [{'srcline': 22, 'description': 'After an acquisition start event, the camera will continuously receive frame trigger events.', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Continuous', 'ctype': 'std::string', 'type': 'str', 'name': 'Continuous'}, {'srcline': 23, 'description': 'The camera will only deliver a single frame trigger event', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SingleFrame', 'ctype': 'std::string', 'type': 'str', 'name': 'SingleFrame'}, {'srcline': 24, 'description': 'The camera will acquire the number of images specified by `~AcquisitionFrameCount`. Further trigger events will be ignored', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'MultiFrame', 'ctype': 'std::string', 'type': 'str', 'name': 'MultiFrame'}, {'srcline': 25, 'description': 'The camera will continuously record images into the camera on-board memory', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Recorder', 'ctype': 'std::string', 'type': 'str', 'name': 'Recorder'}]}", &AvtVimbaCameraConfig::acquisition_mode)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("acquisition_mode", "str", 1, "Camera acquisition mode", "{'enum_description': 'Set Trigger Mode', 'enum': [{'srcline': 22, 'description': 'After an acquisition start event, the camera will continuously receive frame trigger events.', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Continuous', 'ctype': 'std::string', 'type': 'str', 'name': 'Continuous'}, {'srcline': 23, 'description': 'The camera will only deliver a single frame trigger event', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SingleFrame', 'ctype': 'std::string', 'type': 'str', 'name': 'SingleFrame'}, {'srcline': 24, 'description': 'The camera will acquire the number of images specified by `~AcquisitionFrameCount`. Further trigger events will be ignored', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'MultiFrame', 'ctype': 'std::string', 'type': 'str', 'name': 'MultiFrame'}, {'srcline': 25, 'description': 'The camera will continuously record images into the camera on-board memory', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Recorder', 'ctype': 'std::string', 'type': 'str', 'name': 'Recorder'}]}", &AvtVimbaCameraConfig::acquisition_mode)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.acquisition_rate = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.acquisition_rate = 30.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.acquisition_rate = 2.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("acquisition_rate", "double", 0, "Sets the expected triggering rate in externally triggered mode.", "", &AvtVimbaCameraConfig::acquisition_rate)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("acquisition_rate", "double", 0, "Sets the expected triggering rate in externally triggered mode.", "", &AvtVimbaCameraConfig::acquisition_rate)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.trigger_mode = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.trigger_mode = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.trigger_mode = "Freerun";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("trigger_mode", "str", 1, "Camera trigger mode", "{'enum_description': 'Set Trigger Mode', 'enum': [{'srcline': 10, 'description': 'Run at maximum frame rate', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Freerun', 'ctype': 'std::string', 'type': 'str', 'name': 'Freerun'}, {'srcline': 11, 'description': 'External trigger on SyncIn1 line', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Line1', 'ctype': 'std::string', 'type': 'str', 'name': 'Line1'}, {'srcline': 12, 'description': 'External trigger on SyncIn2 line', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Line2', 'ctype': 'std::string', 'type': 'str', 'name': 'Line2'}, {'srcline': 13, 'description': 'External trigger on SyncIn3 line', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Line3', 'ctype': 'std::string', 'type': 'str', 'name': 'Line3'}, {'srcline': 14, 'description': 'External trigger on SyncIn4 line', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Line4', 'ctype': 'std::string', 'type': 'str', 'name': 'Line4'}, {'srcline': 15, 'description': 'Camera self-triggers at a fixed frame rate defined by `~AcquisitionFrameRateAbs`', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'FixedRate', 'ctype': 'std::string', 'type': 'str', 'name': 'FixedRate'}, {'srcline': 16, 'description': 'Software inititated image capture', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Software', 'ctype': 'std::string', 'type': 'str', 'name': 'Software'}]}", &AvtVimbaCameraConfig::trigger_mode)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("trigger_mode", "str", 1, "Camera trigger mode", "{'enum_description': 'Set Trigger Mode', 'enum': [{'srcline': 10, 'description': 'Run at maximum frame rate', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Freerun', 'ctype': 'std::string', 'type': 'str', 'name': 'Freerun'}, {'srcline': 11, 'description': 'External trigger on SyncIn1 line', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Line1', 'ctype': 'std::string', 'type': 'str', 'name': 'Line1'}, {'srcline': 12, 'description': 'External trigger on SyncIn2 line', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Line2', 'ctype': 'std::string', 'type': 'str', 'name': 'Line2'}, {'srcline': 13, 'description': 'External trigger on SyncIn3 line', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Line3', 'ctype': 'std::string', 'type': 'str', 'name': 'Line3'}, {'srcline': 14, 'description': 'External trigger on SyncIn4 line', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Line4', 'ctype': 'std::string', 'type': 'str', 'name': 'Line4'}, {'srcline': 15, 'description': 'Camera self-triggers at a fixed frame rate defined by `~AcquisitionFrameRateAbs`', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'FixedRate', 'ctype': 'std::string', 'type': 'str', 'name': 'FixedRate'}, {'srcline': 16, 'description': 'Software inititated image capture', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Software', 'ctype': 'std::string', 'type': 'str', 'name': 'Software'}]}", &AvtVimbaCameraConfig::trigger_mode)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.trigger_activation = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.trigger_activation = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.trigger_activation = "RisingEdge";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("trigger_activation", "str", 1, "Camera trigger activation", "{'enum_description': 'Set Automatic Control', 'enum': [{'srcline': 17, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'RisingEdge', 'ctype': 'std::string', 'type': 'str', 'name': 'RisingEdge'}, {'srcline': 18, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'FallingEdge', 'ctype': 'std::string', 'type': 'str', 'name': 'FallingEdge'}, {'srcline': 19, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'AnyEdge', 'ctype': 'std::string', 'type': 'str', 'name': 'AnyEdge'}, {'srcline': 20, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'LevelHigh', 'ctype': 'std::string', 'type': 'str', 'name': 'LevelHigh'}, {'srcline': 21, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'LevelLow', 'ctype': 'std::string', 'type': 'str', 'name': 'LevelLow'}]}", &AvtVimbaCameraConfig::trigger_activation)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("trigger_activation", "str", 1, "Camera trigger activation", "{'enum_description': 'Set Automatic Control', 'enum': [{'srcline': 17, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'RisingEdge', 'ctype': 'std::string', 'type': 'str', 'name': 'RisingEdge'}, {'srcline': 18, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'FallingEdge', 'ctype': 'std::string', 'type': 'str', 'name': 'FallingEdge'}, {'srcline': 19, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'AnyEdge', 'ctype': 'std::string', 'type': 'str', 'name': 'AnyEdge'}, {'srcline': 20, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'LevelHigh', 'ctype': 'std::string', 'type': 'str', 'name': 'LevelHigh'}, {'srcline': 21, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'LevelLow', 'ctype': 'std::string', 'type': 'str', 'name': 'LevelLow'}]}", &AvtVimbaCameraConfig::trigger_activation)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.trigger_delay = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.trigger_delay = 60000000.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.trigger_delay = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("trigger_delay", "double", 0, "Trigger delay in us (only valid when set to external trigger)", "", &AvtVimbaCameraConfig::trigger_delay)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("trigger_delay", "double", 0, "Trigger delay in us (only valid when set to external trigger)", "", &AvtVimbaCameraConfig::trigger_delay)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.exposure = 41.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.exposure = 60000000.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.exposure = 1000.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("exposure", "double", 0, "Camera exposure time in microseconds.", "", &AvtVimbaCameraConfig::exposure)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("exposure", "double", 0, "Camera exposure time in microseconds.", "", &AvtVimbaCameraConfig::exposure)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.exposure_auto = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.exposure_auto = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.exposure_auto = "Off";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("exposure_auto", "str", 0, "Sets the camera exposure. If continously automatic, causes the `~exposure` setting to be ignored.", "{'enum_description': 'Set Automatic Control', 'enum': [{'srcline': 35, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Off', 'ctype': 'std::string', 'type': 'str', 'name': 'Off'}, {'srcline': 36, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Once', 'ctype': 'std::string', 'type': 'str', 'name': 'Once'}, {'srcline': 37, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Continuous', 'ctype': 'std::string', 'type': 'str', 'name': 'Auto'}]}", &AvtVimbaCameraConfig::exposure_auto)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("exposure_auto", "str", 0, "Sets the camera exposure. If continously automatic, causes the `~exposure` setting to be ignored.", "{'enum_description': 'Set Automatic Control', 'enum': [{'srcline': 35, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Off', 'ctype': 'std::string', 'type': 'str', 'name': 'Off'}, {'srcline': 36, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Once', 'ctype': 'std::string', 'type': 'str', 'name': 'Once'}, {'srcline': 37, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Continuous', 'ctype': 'std::string', 'type': 'str', 'name': 'Auto'}]}", &AvtVimbaCameraConfig::exposure_auto)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.exposure_auto_tol = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.exposure_auto_tol = 50;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.exposure_auto_tol = 5;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("exposure_auto_tol", "int", 0, "Tolerance in variation from ExposureAutoTarget in which the auto exposure algorithm will not respond.", "", &AvtVimbaCameraConfig::exposure_auto_tol)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("exposure_auto_tol", "int", 0, "Tolerance in variation from ExposureAutoTarget in which the auto exposure algorithm will not respond.", "", &AvtVimbaCameraConfig::exposure_auto_tol)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.exposure_auto_max = 41;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.exposure_auto_max = 60000000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.exposure_auto_max = 500000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("exposure_auto_max", "int", 0, "The max exposure time in auto exposure mode, in microseconds.", "", &AvtVimbaCameraConfig::exposure_auto_max)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("exposure_auto_max", "int", 0, "The max exposure time in auto exposure mode, in microseconds.", "", &AvtVimbaCameraConfig::exposure_auto_max)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.exposure_auto_min = 41;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.exposure_auto_min = 60000000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.exposure_auto_min = 41;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("exposure_auto_min", "int", 0, "The min exposure time in auto exposure mode, in microseconds.", "", &AvtVimbaCameraConfig::exposure_auto_min)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("exposure_auto_min", "int", 0, "The min exposure time in auto exposure mode, in microseconds.", "", &AvtVimbaCameraConfig::exposure_auto_min)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.exposure_auto_outliers = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.exposure_auto_outliers = 10000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.exposure_auto_outliers = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("exposure_auto_outliers", "int", 0, "The total pixels from top of the distribution that are ignored by the auto exposure algorithm (0.01% increments)", "", &AvtVimbaCameraConfig::exposure_auto_outliers)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("exposure_auto_outliers", "int", 0, "The total pixels from top of the distribution that are ignored by the auto exposure algorithm (0.01% increments)", "", &AvtVimbaCameraConfig::exposure_auto_outliers)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.exposure_auto_rate = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.exposure_auto_rate = 100;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.exposure_auto_rate = 100;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("exposure_auto_rate", "int", 0, "The rate at which the auto exposure function changes the exposure setting.100% is auto exposure adjustments running at full speed, and 50% is half speed.", "", &AvtVimbaCameraConfig::exposure_auto_rate)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("exposure_auto_rate", "int", 0, "The rate at which the auto exposure function changes the exposure setting.100% is auto exposure adjustments running at full speed, and 50% is half speed.", "", &AvtVimbaCameraConfig::exposure_auto_rate)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.exposure_auto_target = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.exposure_auto_target = 100;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.exposure_auto_target = 50;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("exposure_auto_target", "int", 0, "The auto exposure target mean value as a percentage, from 0=black to 100=white.", "", &AvtVimbaCameraConfig::exposure_auto_target)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("exposure_auto_target", "int", 0, "The auto exposure target mean value as a percentage, from 0=black to 100=white.", "", &AvtVimbaCameraConfig::exposure_auto_target)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.gain = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.gain = 32.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.gain = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("gain", "double", 0, "The gain level in dB.", "", &AvtVimbaCameraConfig::gain)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("gain", "double", 0, "The gain level in dB.", "", &AvtVimbaCameraConfig::gain)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.gain_auto = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.gain_auto = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.gain_auto = "Off";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("gain_auto", "str", 0, "Sets the analog gain. If continously automatic, causes the `~gain` setting to be ignored.", "{'enum_description': 'Set Automatic Control', 'enum': [{'srcline': 35, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Off', 'ctype': 'std::string', 'type': 'str', 'name': 'Off'}, {'srcline': 36, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Once', 'ctype': 'std::string', 'type': 'str', 'name': 'Once'}, {'srcline': 37, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Continuous', 'ctype': 'std::string', 'type': 'str', 'name': 'Auto'}]}", &AvtVimbaCameraConfig::gain_auto)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("gain_auto", "str", 0, "Sets the analog gain. If continously automatic, causes the `~gain` setting to be ignored.", "{'enum_description': 'Set Automatic Control', 'enum': [{'srcline': 35, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Off', 'ctype': 'std::string', 'type': 'str', 'name': 'Off'}, {'srcline': 36, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Once', 'ctype': 'std::string', 'type': 'str', 'name': 'Once'}, {'srcline': 37, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Continuous', 'ctype': 'std::string', 'type': 'str', 'name': 'Auto'}]}", &AvtVimbaCameraConfig::gain_auto)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.gain_auto_tol = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.gain_auto_tol = 50;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.gain_auto_tol = 5;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("gain_auto_tol", "int", 0, "Tolerance in variation from GainAutoTarget in which the auto exposure algorithm will not respond.", "", &AvtVimbaCameraConfig::gain_auto_tol)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("gain_auto_tol", "int", 0, "Tolerance in variation from GainAutoTarget in which the auto exposure algorithm will not respond.", "", &AvtVimbaCameraConfig::gain_auto_tol)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.gain_auto_max = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.gain_auto_max = 32.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.gain_auto_max = 32.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("gain_auto_max", "double", 0, "The max gain level in auto gain mode, in dB.", "", &AvtVimbaCameraConfig::gain_auto_max)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("gain_auto_max", "double", 0, "The max gain level in auto gain mode, in dB.", "", &AvtVimbaCameraConfig::gain_auto_max)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.gain_auto_min = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.gain_auto_min = 32.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.gain_auto_min = 0.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("gain_auto_min", "double", 0, "The min gain level in auto gain mode, in dB.", "", &AvtVimbaCameraConfig::gain_auto_min)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("gain_auto_min", "double", 0, "The min gain level in auto gain mode, in dB.", "", &AvtVimbaCameraConfig::gain_auto_min)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.gain_auto_outliers = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.gain_auto_outliers = 10000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.gain_auto_outliers = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("gain_auto_outliers", "int", 0, "The total pixels from top of the distribution that are ignored by the auto gain algorithm (0.01% increments).", "", &AvtVimbaCameraConfig::gain_auto_outliers)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("gain_auto_outliers", "int", 0, "The total pixels from top of the distribution that are ignored by the auto gain algorithm (0.01% increments).", "", &AvtVimbaCameraConfig::gain_auto_outliers)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.gain_auto_rate = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.gain_auto_rate = 100;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.gain_auto_rate = 100;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("gain_auto_rate", "int", 0, "The rate percentage at which the auto gain function changes.", "", &AvtVimbaCameraConfig::gain_auto_rate)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("gain_auto_rate", "int", 0, "The rate percentage at which the auto gain function changes.", "", &AvtVimbaCameraConfig::gain_auto_rate)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.gain_auto_target = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.gain_auto_target = 100;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.gain_auto_target = 50;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("gain_auto_target", "int", 0, "The general lightness or darkness of the auto gain feature. A percentage of maximum brightness.", "", &AvtVimbaCameraConfig::gain_auto_target)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("gain_auto_target", "int", 0, "The general lightness or darkness of the auto gain feature. A percentage of maximum brightness.", "", &AvtVimbaCameraConfig::gain_auto_target)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.balance_ratio_abs = 0.25;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.balance_ratio_abs = 4.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.balance_ratio_abs = 1.0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("balance_ratio_abs", "double", 0, "Adjusts the gain of the channel selected in the `~BalanceRatioSelector`", "", &AvtVimbaCameraConfig::balance_ratio_abs)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<double>("balance_ratio_abs", "double", 0, "Adjusts the gain of the channel selected in the `~BalanceRatioSelector`", "", &AvtVimbaCameraConfig::balance_ratio_abs)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.balance_ratio_selector = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.balance_ratio_selector = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.balance_ratio_selector = "Red";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("balance_ratio_selector", "str", 0, "Select the Red or Blue channel to adjust with `~BalanceRatioAbs`", "{'enum_description': 'Select the Red or Blue channel to adjust with `~BalanceRatioAbs`', 'enum': [{'srcline': 38, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Red', 'ctype': 'std::string', 'type': 'str', 'name': 'Red'}, {'srcline': 39, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Blue', 'ctype': 'std::string', 'type': 'str', 'name': 'Blue'}]}", &AvtVimbaCameraConfig::balance_ratio_selector)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("balance_ratio_selector", "str", 0, "Select the Red or Blue channel to adjust with `~BalanceRatioAbs`", "{'enum_description': 'Select the Red or Blue channel to adjust with `~BalanceRatioAbs`', 'enum': [{'srcline': 38, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Red', 'ctype': 'std::string', 'type': 'str', 'name': 'Red'}, {'srcline': 39, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Blue', 'ctype': 'std::string', 'type': 'str', 'name': 'Blue'}]}", &AvtVimbaCameraConfig::balance_ratio_selector)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.whitebalance_auto = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.whitebalance_auto = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.whitebalance_auto = "Off";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("whitebalance_auto", "str", 0, "Whether whitebalance will continuously adjust to the current scene. Causes the `~whitebalance_red` and `~whitebalance_blue` settings to be ignored.", "{'enum_description': 'Set Automatic Control', 'enum': [{'srcline': 35, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Off', 'ctype': 'std::string', 'type': 'str', 'name': 'Off'}, {'srcline': 36, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Once', 'ctype': 'std::string', 'type': 'str', 'name': 'Once'}, {'srcline': 37, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Continuous', 'ctype': 'std::string', 'type': 'str', 'name': 'Auto'}]}", &AvtVimbaCameraConfig::whitebalance_auto)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("whitebalance_auto", "str", 0, "Whether whitebalance will continuously adjust to the current scene. Causes the `~whitebalance_red` and `~whitebalance_blue` settings to be ignored.", "{'enum_description': 'Set Automatic Control', 'enum': [{'srcline': 35, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Off', 'ctype': 'std::string', 'type': 'str', 'name': 'Off'}, {'srcline': 36, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Once', 'ctype': 'std::string', 'type': 'str', 'name': 'Once'}, {'srcline': 37, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Continuous', 'ctype': 'std::string', 'type': 'str', 'name': 'Auto'}]}", &AvtVimbaCameraConfig::whitebalance_auto)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.whitebalance_auto_tol = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.whitebalance_auto_tol = 50;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.whitebalance_auto_tol = 5;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("whitebalance_auto_tol", "int", 0, "Tolerance allowed from the ideal white balance values", "", &AvtVimbaCameraConfig::whitebalance_auto_tol)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("whitebalance_auto_tol", "int", 0, "Tolerance allowed from the ideal white balance values", "", &AvtVimbaCameraConfig::whitebalance_auto_tol)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.whitebalance_auto_rate = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.whitebalance_auto_rate = 100;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.whitebalance_auto_rate = 100;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("whitebalance_auto_rate", "int", 0, "Rate of white balance adjustments, from 1 (slowest) to 100 (fastest).", "", &AvtVimbaCameraConfig::whitebalance_auto_rate)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("whitebalance_auto_rate", "int", 0, "Rate of white balance adjustments, from 1 (slowest) to 100 (fastest).", "", &AvtVimbaCameraConfig::whitebalance_auto_rate)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.binning_x = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.binning_x = 8;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.binning_x = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("binning_x", "int", 0, "Number of pixels to bin together horizontally.", "", &AvtVimbaCameraConfig::binning_x)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("binning_x", "int", 0, "Number of pixels to bin together horizontally.", "", &AvtVimbaCameraConfig::binning_x)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.binning_y = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.binning_y = 14;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.binning_y = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("binning_y", "int", 0, "Number of pixels to bin together vertically.", "", &AvtVimbaCameraConfig::binning_y)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("binning_y", "int", 0, "Number of pixels to bin together vertically.", "", &AvtVimbaCameraConfig::binning_y)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.decimation_x = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.decimation_x = 8;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.decimation_x = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("decimation_x", "int", 0, "Number of decimation operations in x.", "", &AvtVimbaCameraConfig::decimation_x)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("decimation_x", "int", 0, "Number of decimation operations in x.", "", &AvtVimbaCameraConfig::decimation_x)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.decimation_y = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.decimation_y = 8;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.decimation_y = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("decimation_y", "int", 0, "Number of decimation operations in y.", "", &AvtVimbaCameraConfig::decimation_y)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("decimation_y", "int", 0, "Number of decimation operations in y.", "", &AvtVimbaCameraConfig::decimation_y)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.width = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.width = 2452;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.width = 2452;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("width", "int", 0, "Width of the region of interest (0 for automatic).", "", &AvtVimbaCameraConfig::width)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("width", "int", 0, "Width of the region of interest (0 for automatic).", "", &AvtVimbaCameraConfig::width)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.height = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.height = 2056;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.height = 2056;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("height", "int", 0, "Height of the region of interest (0 for automatic).", "", &AvtVimbaCameraConfig::height)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("height", "int", 0, "Height of the region of interest (0 for automatic).", "", &AvtVimbaCameraConfig::height)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.roi_width = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.roi_width = 2451;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.roi_width = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("roi_width", "int", 0, "X offset of the region of interest.", "", &AvtVimbaCameraConfig::roi_width)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("roi_width", "int", 0, "X offset of the region of interest.", "", &AvtVimbaCameraConfig::roi_width)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.roi_height = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.roi_height = 2451;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.roi_height = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("roi_height", "int", 0, "X offset of the region of interest.", "", &AvtVimbaCameraConfig::roi_height)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("roi_height", "int", 0, "X offset of the region of interest.", "", &AvtVimbaCameraConfig::roi_height)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.roi_offset_x = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.roi_offset_x = 2451;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.roi_offset_x = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("roi_offset_x", "int", 0, "X offset of the region of interest.", "", &AvtVimbaCameraConfig::roi_offset_x)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("roi_offset_x", "int", 0, "X offset of the region of interest.", "", &AvtVimbaCameraConfig::roi_offset_x)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.roi_offset_y = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.roi_offset_y = 2055;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.roi_offset_y = 0;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("roi_offset_y", "int", 0, "Y offset of the region of interest.", "", &AvtVimbaCameraConfig::roi_offset_y)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("roi_offset_y", "int", 0, "Y offset of the region of interest.", "", &AvtVimbaCameraConfig::roi_offset_y)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.pixel_format = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.pixel_format = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.pixel_format = "Mono8";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("pixel_format", "str", 3, "Format of the image data.", "{'enum_description': 'Set Pixel Format', 'enum': [{'srcline': 27, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Mono8', 'ctype': 'std::string', 'type': 'str', 'name': 'Mono8'}, {'srcline': 28, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Mono12', 'ctype': 'std::string', 'type': 'str', 'name': 'Mono12'}, {'srcline': 29, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Mono12Packed', 'ctype': 'std::string', 'type': 'str', 'name': 'Mono12Packed'}, {'srcline': 30, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'BayerRG8', 'ctype': 'std::string', 'type': 'str', 'name': 'BayerRG8'}, {'srcline': 31, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'BayerRG12Packed', 'ctype': 'std::string', 'type': 'str', 'name': 'BayerRG12Packed'}, {'srcline': 32, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'BayerGR12', 'ctype': 'std::string', 'type': 'str', 'name': 'BayerGR12'}, {'srcline': 33, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'RGB8Packed', 'ctype': 'std::string', 'type': 'str', 'name': 'RGB8Packed'}, {'srcline': 34, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'BGR8Packed', 'ctype': 'std::string', 'type': 'str', 'name': 'BGR8Packed'}]}", &AvtVimbaCameraConfig::pixel_format)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("pixel_format", "str", 3, "Format of the image data.", "{'enum_description': 'Set Pixel Format', 'enum': [{'srcline': 27, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Mono8', 'ctype': 'std::string', 'type': 'str', 'name': 'Mono8'}, {'srcline': 28, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Mono12', 'ctype': 'std::string', 'type': 'str', 'name': 'Mono12'}, {'srcline': 29, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Mono12Packed', 'ctype': 'std::string', 'type': 'str', 'name': 'Mono12Packed'}, {'srcline': 30, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'BayerRG8', 'ctype': 'std::string', 'type': 'str', 'name': 'BayerRG8'}, {'srcline': 31, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'BayerRG12Packed', 'ctype': 'std::string', 'type': 'str', 'name': 'BayerRG12Packed'}, {'srcline': 32, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'BayerGR12', 'ctype': 'std::string', 'type': 'str', 'name': 'BayerGR12'}, {'srcline': 33, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'RGB8Packed', 'ctype': 'std::string', 'type': 'str', 'name': 'RGB8Packed'}, {'srcline': 34, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'BGR8Packed', 'ctype': 'std::string', 'type': 'str', 'name': 'BGR8Packed'}]}", &AvtVimbaCameraConfig::pixel_format)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.stream_bytes_per_second = 1;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.stream_bytes_per_second = 115000000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.stream_bytes_per_second = 45000000;
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("stream_bytes_per_second", "int", 0, "Limits the data rate of the camera.", "", &AvtVimbaCameraConfig::stream_bytes_per_second)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<int>("stream_bytes_per_second", "int", 0, "Limits the data rate of the camera.", "", &AvtVimbaCameraConfig::stream_bytes_per_second)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.sync_in_selector = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.sync_in_selector = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.sync_in_selector = "SyncIn1";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("sync_in_selector", "str", 1, "Selects the sync-out line to control", "{'enum_description': 'Sync-in selector', 'enum': [{'srcline': 42, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncIn1', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncIn1'}, {'srcline': 43, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncIn2', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncIn2'}, {'srcline': 44, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncIn3', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncIn3'}, {'srcline': 45, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncIn4', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncIn4'}]}", &AvtVimbaCameraConfig::sync_in_selector)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("sync_in_selector", "str", 1, "Selects the sync-out line to control", "{'enum_description': 'Sync-in selector', 'enum': [{'srcline': 42, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncIn1', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncIn1'}, {'srcline': 43, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncIn2', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncIn2'}, {'srcline': 44, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncIn3', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncIn3'}, {'srcline': 45, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncIn4', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncIn4'}]}", &AvtVimbaCameraConfig::sync_in_selector)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.sync_out_polarity = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.sync_out_polarity = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.sync_out_polarity = "Normal";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("sync_out_polarity", "str", 1, "Polarity applied to the sync-out line specified by `sync_out_selector`", "{'enum_description': 'Polarity', 'enum': [{'srcline': 40, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Normal', 'ctype': 'std::string', 'type': 'str', 'name': 'Normal'}, {'srcline': 41, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Invert', 'ctype': 'std::string', 'type': 'str', 'name': 'Invert'}]}", &AvtVimbaCameraConfig::sync_out_polarity)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("sync_out_polarity", "str", 1, "Polarity applied to the sync-out line specified by `sync_out_selector`", "{'enum_description': 'Polarity', 'enum': [{'srcline': 40, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Normal', 'ctype': 'std::string', 'type': 'str', 'name': 'Normal'}, {'srcline': 41, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Invert', 'ctype': 'std::string', 'type': 'str', 'name': 'Invert'}]}", &AvtVimbaCameraConfig::sync_out_polarity)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.sync_out_selector = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.sync_out_selector = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.sync_out_selector = "SyncOut1";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("sync_out_selector", "str", 1, "Selects the sync-out line to control", "{'enum_description': 'Sync-out selector', 'enum': [{'srcline': 46, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncOut1', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncOut1'}, {'srcline': 47, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncOut2', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncOut2'}, {'srcline': 48, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncOut3', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncOut3'}, {'srcline': 49, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncOut4', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncOut4'}]}", &AvtVimbaCameraConfig::sync_out_selector)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("sync_out_selector", "str", 1, "Selects the sync-out line to control", "{'enum_description': 'Sync-out selector', 'enum': [{'srcline': 46, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncOut1', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncOut1'}, {'srcline': 47, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncOut2', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncOut2'}, {'srcline': 48, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncOut3', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncOut3'}, {'srcline': 49, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'SyncOut4', 'ctype': 'std::string', 'type': 'str', 'name': 'SyncOut4'}]}", &AvtVimbaCameraConfig::sync_out_selector)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.sync_out_source = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.sync_out_source = "";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.sync_out_source = "GPO";
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("sync_out_source", "str", 1, "Signal source of the sync-out line specified by `sync_out_selector`", "{'enum_description': 'Sync-out signal', 'enum': [{'srcline': 50, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'GPO', 'ctype': 'std::string', 'type': 'str', 'name': 'GPO'}, {'srcline': 51, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'AcquisitionTriggerReady', 'ctype': 'std::string', 'type': 'str', 'name': 'AcquisitionTriggerReady'}, {'srcline': 52, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'FrameTriggerReady', 'ctype': 'std::string', 'type': 'str', 'name': 'FrameTriggerReady'}, {'srcline': 53, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'FrameTrigger', 'ctype': 'std::string', 'type': 'str', 'name': 'FrameTrigger'}, {'srcline': 54, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Exposing', 'ctype': 'std::string', 'type': 'str', 'name': 'Exposing'}, {'srcline': 55, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'FrameReadout', 'ctype': 'std::string', 'type': 'str', 'name': 'FrameReadout'}, {'srcline': 56, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Imaging', 'ctype': 'std::string', 'type': 'str', 'name': 'Imaging'}, {'srcline': 57, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Acquiring', 'ctype': 'std::string', 'type': 'str', 'name': 'Acquiring'}, {'srcline': 58, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'LineIn1', 'ctype': 'std::string', 'type': 'str', 'name': 'LineIn1'}, {'srcline': 59, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'LineIn2', 'ctype': 'std::string', 'type': 'str', 'name': 'LineIn2'}]}", &AvtVimbaCameraConfig::sync_out_source)));
//#line 262 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr(new AvtVimbaCameraConfig::ParamDescription<std::string>("sync_out_source", "str", 1, "Signal source of the sync-out line specified by `sync_out_selector`", "{'enum_description': 'Sync-out signal', 'enum': [{'srcline': 50, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'GPO', 'ctype': 'std::string', 'type': 'str', 'name': 'GPO'}, {'srcline': 51, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'AcquisitionTriggerReady', 'ctype': 'std::string', 'type': 'str', 'name': 'AcquisitionTriggerReady'}, {'srcline': 52, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'FrameTriggerReady', 'ctype': 'std::string', 'type': 'str', 'name': 'FrameTriggerReady'}, {'srcline': 53, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'FrameTrigger', 'ctype': 'std::string', 'type': 'str', 'name': 'FrameTrigger'}, {'srcline': 54, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Exposing', 'ctype': 'std::string', 'type': 'str', 'name': 'Exposing'}, {'srcline': 55, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'FrameReadout', 'ctype': 'std::string', 'type': 'str', 'name': 'FrameReadout'}, {'srcline': 56, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Imaging', 'ctype': 'std::string', 'type': 'str', 'name': 'Imaging'}, {'srcline': 57, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'Acquiring', 'ctype': 'std::string', 'type': 'str', 'name': 'Acquiring'}, {'srcline': 58, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'LineIn1', 'ctype': 'std::string', 'type': 'str', 'name': 'LineIn1'}, {'srcline': 59, 'description': '', 'srcfile': '/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'LineIn2', 'ctype': 'std::string', 'type': 'str', 'name': 'LineIn2'}]}", &AvtVimbaCameraConfig::sync_out_source)));
//#line 233 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 233 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(AvtVimbaCameraConfig::AbstractGroupDescriptionConstPtr(new AvtVimbaCameraConfig::GroupDescription<AvtVimbaCameraConfig::DEFAULT, AvtVimbaCameraConfig>(Default)));
//#line 390 "/opt/ros/hydro/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<AvtVimbaCameraConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__); 
    }
    std::vector<AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<AvtVimbaCameraConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    AvtVimbaCameraConfig __max__;
    AvtVimbaCameraConfig __min__;
    AvtVimbaCameraConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const AvtVimbaCameraConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static AvtVimbaCameraConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &AvtVimbaCameraConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const AvtVimbaCameraConfig &AvtVimbaCameraConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const AvtVimbaCameraConfig &AvtVimbaCameraConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const AvtVimbaCameraConfig &AvtVimbaCameraConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<AvtVimbaCameraConfig::AbstractParamDescriptionConstPtr> &AvtVimbaCameraConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<AvtVimbaCameraConfig::AbstractGroupDescriptionConstPtr> &AvtVimbaCameraConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const AvtVimbaCameraConfigStatics *AvtVimbaCameraConfig::__get_statics__()
  {
    const static AvtVimbaCameraConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = AvtVimbaCameraConfigStatics::get_instance();
    
    return statics;
  }

//#line 10 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Freerun = "Freerun";
//#line 11 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Line1 = "Line1";
//#line 12 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Line2 = "Line2";
//#line 13 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Line3 = "Line3";
//#line 14 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Line4 = "Line4";
//#line 15 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_FixedRate = "FixedRate";
//#line 16 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Software = "Software";
//#line 17 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_RisingEdge = "RisingEdge";
//#line 18 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_FallingEdge = "FallingEdge";
//#line 19 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_AnyEdge = "AnyEdge";
//#line 20 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_LevelHigh = "LevelHigh";
//#line 21 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_LevelLow = "LevelLow";
//#line 22 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Continuous = "Continuous";
//#line 23 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_SingleFrame = "SingleFrame";
//#line 24 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_MultiFrame = "MultiFrame";
//#line 25 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Recorder = "Recorder";
//#line 27 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Mono8 = "Mono8";
//#line 28 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Mono12 = "Mono12";
//#line 29 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Mono12Packed = "Mono12Packed";
//#line 30 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_BayerRG8 = "BayerRG8";
//#line 31 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_BayerRG12Packed = "BayerRG12Packed";
//#line 32 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_BayerGR12 = "BayerGR12";
//#line 33 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_RGB8Packed = "RGB8Packed";
//#line 34 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_BGR8Packed = "BGR8Packed";
//#line 35 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Off = "Off";
//#line 36 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Once = "Once";
//#line 37 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Auto = "Continuous";
//#line 38 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Red = "Red";
//#line 39 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Blue = "Blue";
//#line 40 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Normal = "Normal";
//#line 41 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Invert = "Invert";
//#line 42 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_SyncIn1 = "SyncIn1";
//#line 43 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_SyncIn2 = "SyncIn2";
//#line 44 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_SyncIn3 = "SyncIn3";
//#line 45 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_SyncIn4 = "SyncIn4";
//#line 46 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_SyncOut1 = "SyncOut1";
//#line 47 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_SyncOut2 = "SyncOut2";
//#line 48 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_SyncOut3 = "SyncOut3";
//#line 49 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_SyncOut4 = "SyncOut4";
//#line 50 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_GPO = "GPO";
//#line 51 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_AcquisitionTriggerReady = "AcquisitionTriggerReady";
//#line 52 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_FrameTriggerReady = "FrameTriggerReady";
//#line 53 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_FrameTrigger = "FrameTrigger";
//#line 54 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Exposing = "Exposing";
//#line 55 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_FrameReadout = "FrameReadout";
//#line 56 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Imaging = "Imaging";
//#line 57 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_Acquiring = "Acquiring";
//#line 58 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_LineIn1 = "LineIn1";
//#line 59 "/tmp/buildd/ros-hydro-avt-vimba-camera-0.0.2-0raring-20150808-0634/cfg/AvtVimbaCamera.cfg"
      const char * const AvtVimbaCamera_LineIn2 = "LineIn2";
}

#endif // __AVTVIMBACAMERARECONFIGURATOR_H__
